//
// Created by zzh on 7/27/22.
//

#include "basiceffects.h"
#include <kwinglutils.h>
#include <QDBusConnection>
#include <QDBusError>
#include <syslog.h>

namespace KWin
{

BasicEffects::BasicEffects() {
//    m_shader = ShaderManager::instance()->generateShaderFromFile(ShaderTrait::MapTexture, QString(), QStringLiteral(":/effects/basiceffects/shaders/basiceffects.frag"));
    reconfigure(0, 1.0);
    bool fuck = QDBusConnection::sessionBus().connect(QString(),
                                          QStringLiteral("/Test"),
                                          QStringLiteral("org.test.test"),
                                          QStringLiteral("test"),
                                          this, SLOT(reconfigure(int, double)));

}

BasicEffects::~BasicEffects() {
//    if (m_shader)
//        delete m_shader;
//    m_shader = nullptr;
}

void BasicEffects::reconfigure(int state, qreal value) {
    if (state == static_cast<size_t>(EffectState::Normal)) {
        m_effectState = EffectState::Normal;
    } else if (state == static_cast<size_t>(EffectState::BrightnessChange)) {
        m_effectState = EffectState::BrightnessChange;
        if (value < 0.1)
            m_targetBrightness = 0.1;
        else if (value > 1.0)
            m_targetBrightness = 1.0;
        else
            m_targetBrightness = value;
    } else if (state == static_cast<size_t>(EffectState::SaturationChange)) {
        m_effectState = EffectState::SaturationChange;
        m_targetSaturation = value;
    }
    m_timeLine.setDuration(std::chrono::milliseconds(1000));
    m_timeLine.reset();
    m_lastPresentTime = std::chrono::milliseconds::zero();
}

bool BasicEffects::isActive() const {
    return true;
//    return static_cast<bool>(m_effectState);
}

bool BasicEffects::provides(Feature) {
    return true;
}

void BasicEffects::prePaintScreen(ScreenPrePaintData &data, std::chrono::milliseconds presentTime) {
    std::chrono::milliseconds delta = std::chrono::milliseconds::zero();
    if (m_lastPresentTime.count())
        delta = presentTime - m_lastPresentTime;
    m_timeLine.update(delta);
    if (m_timeLine.done()) {
        syslog(LOG_WARNING, "%s \n", data.screen->name().toStdString().data());
        m_effectState = EffectState::Normal;
        m_presentBrightness = m_targetBrightness;
        m_presentSaturation = m_targetSaturation;
    }
    m_lastPresentTime = presentTime;
    if (static_cast<int>(m_effectState))
        effects->addRepaintFull();
    effects->prePaintScreen(data, presentTime);
}

void BasicEffects::drawWindow(EffectWindow *w, int mask, const QRegion &region, WindowPaintData &data) {
    if (static_cast<int>(m_effectState)) {
        data.setBrightness(m_presentBrightness + (m_targetBrightness - m_presentBrightness) * m_timeLine.value());
        data.setSaturation(m_presentSaturation + (m_targetSaturation - m_presentSaturation) * m_timeLine.value());
    }
    effects->drawWindow(w, mask, region, data);
}

bool BasicEffects::supported() {
    return effects->compositingType() == OpenGLCompositing;
}

}