//
// Created by zzh on 7/27/22.
//

#ifndef KWIN_BASICEFFECTS_H
#define KWIN_BASICEFFECTS_H

#include <kwineffects.h>

namespace KWin
{

class GLShader;
enum class EffectState {
    Normal,
    BrightnessChange,
    SaturationChange
};
/**
* Inverts desktop's colors
*/
class BasicEffects
        : public Effect
{
Q_OBJECT
public:
    BasicEffects();
    ~BasicEffects() override;

    void prePaintScreen(ScreenPrePaintData &data, std::chrono::milliseconds presentTime);
    void drawWindow(EffectWindow* w, int mask, const QRegion &region, WindowPaintData& data) override;
    bool isActive() const override;
    bool provides(Feature) override;
    int requestedEffectChainPosition() const override;
    static bool supported();
public Q_SLOTS:
    void reconfigure(int, qreal);

private:
    GLShader* m_shader;
    TimeLine m_timeLine;
    std::chrono::milliseconds m_lastPresentTime = std::chrono::milliseconds::zero();
    EffectState m_effectState = EffectState::Normal;
    qreal m_targetBrightness = 1.0;
    qreal m_presentBrightness = 1.0;
    qreal m_targetSaturation = 1.0;
    qreal m_presentSaturation = 1.0;
};

inline int BasicEffects::requestedEffectChainPosition() const
{
    return 99;
}

} // namespace

#endif //KWIN_BASICEFFECTS_H
